﻿Public Class Form1

    Dim m_SourceFilename As String = "c:\Program Files\Tracker Software\PDF-XChange PRO 5 SDK\Examples\OcrSDKExamples\CExamples\test-input\sample_pages.pdf"
    Private m_DestFilename As String = "c:\Program Files\Tracker Software\PDF-XChange PRO 5 SDK\Examples\OcrSDKExamples\CExamples\test-output\sample_pages.pdf"
    Private m_Datapath As String = "c:\Program Files\Tracker Software\PDF-XChange PRO 5 SDK\Examples\OCRLanguages\"

    Private m_Language As PDFXOCR_Funcs.PXO_Language = PDFXOCR_Funcs.PXO_Language.PXO_English
    Private m_DPI As Integer = 300

    Private m_CallbackFunc As PDFXOCR_Funcs.PXO_CALLBACK_FUNC
    Private Shared textStatusBox As System.Windows.Forms.TextBox
    Private Shared bContinue As Boolean

    Private Shared Function CallbackFunc(ByVal state As Integer, ByVal level As Integer, ByRef param As Integer) As Boolean
        Dim strmessage As String = "Unknown status."
        Dim type As Integer = level Mod 4
        Dim page As Integer = (level - 1) / 4

        Select Case state
            Case PDFXOCR_Funcs.PXO_CallbackStage.PXOClb_Start
                strmessage = "Starting OCR..."
            Case PDFXOCR_Funcs.PXO_CallbackStage.PXOClb_Processing
                Select Case type
                    Case 1
                        strmessage = "Rasterizing"
                    Case 2
                        strmessage = "Auto-rotating"
                    Case 3
                        strmessage = "Running OCR"
                    Case 0
                        strmessage = "Placing results"
                End Select
            Case PDFXOCR_Funcs.PXO_CallbackStage.PXOClb_Finish
                strmessage = "Finished."
        End Select

        strmessage = strmessage + ": page " + page.ToString()
        textStatusBox.Text = strmessage
        textStatusBox.Update()
        Return bContinue
    End Function

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        lbLanguages.Items.AddRange(PDFXOCR_Funcs.OCR_LangFullArrayW)
        lbLanguages.SelectedIndex = m_Language
        cbDPI.SelectedIndex = m_DPI / 100 - 1
        tbDataPath.Text = m_Datapath
        tbSourcePath.Text = m_SourceFilename
        tbDestinationPath.Text = m_DestFilename
        textStatusBox = tbStatus
        m_CallbackFunc = New PDFXOCR_Funcs.PXO_CALLBACK_FUNC(AddressOf CallbackFunc)
    End Sub

    Private Sub btBrowseData_Click(sender As Object, e As EventArgs) Handles btBrowseData.Click
        FolderBrowserDialog1.SelectedPath = m_Datapath
        If DialogResult.OK = FolderBrowserDialog1.ShowDialog Then
            m_Datapath = FolderBrowserDialog1.SelectedPath
            m_Datapath = m_Datapath + "\\"
            tbDataPath.Text = m_Datapath
        End If
    End Sub

    Private Sub btBrowseSource_Click(sender As Object, e As EventArgs) Handles btBrowseSource.Click
        OpenFileDialog1.FileName = m_SourceFilename
        If DialogResult.OK = OpenFileDialog1.ShowDialog Then
            m_SourceFilename = OpenFileDialog1.FileName
            tbSourcePath.Text = m_SourceFilename
        End If
    End Sub

    Private Sub btBrowseDestination_Click(sender As Object, e As EventArgs) Handles btBrowseDestination.Click
        SaveFileDialog1.FileName = m_DestFilename
        If DialogResult.OK = SaveFileDialog1.ShowDialog Then
            m_DestFilename = SaveFileDialog1.FileName
            tbDestinationPath.Text = m_DestFilename
        End If
    End Sub

    Private Sub btErrorCodes_Click(sender As Object, e As EventArgs) Handles btErrorCodes.Click
        Dim er As String = "OCR return codes (in hexadecimal): " + vbCr +
                            "0          OCR_OK                 " + vbCr +
                            "820A04B0   OCR_ERR_NOTIMPL        " + vbCr +
                            "820A0001   OCR_ERR_INVARG         " + vbCr +
                            "C20A03E8   OCR_ERR_MEMALLOC       " + vbCr +
                            "C20A01F4   OCR_ERR_USER_BREAK     " + vbCr +
                            "420A2710   OCR_WRN_USER_BREAK     " + vbCr +
                            "820A2711   OCR_ERR_DOCNOTREAD     " + vbCr +
                            "820A2712   OCR_ERR_WRONGPAGENUMBER" + vbCr +
                            "820A2713   OCR_ERR_DOCHASNOPAGES  " + vbCr +
                            "820A2714   OCR_ERR_NOTLICENSED    " + vbCr +
                            "420A2715   OCR_WRN_NOTLICENSED    " + vbCr +
                            "420A2716   OCR_WRN_NORESULTS      " + vbCr +
                            "820A2717   OCR_ERR_INTERNAL       " + vbCr +
                            "820A2718   OCR_ERR_POINTER        " + vbCr +
                            "420A2719   OCR_WRN_NOTROTATED     " + vbCr +
                            "420A271A   OCR_WRN_FIELDBOUNDS    " + vbCr +
                            "820A271B   OCR_ERR_FIELDBOUNDS    "
        MessageBox.Show(er)
    End Sub

    Private Sub lbLanguages_SelectedIndexChanged(sender As Object, e As EventArgs) Handles lbLanguages.SelectedIndexChanged
        m_Language = lbLanguages.SelectedIndex
    End Sub

    Private Sub btCancel_Click(sender As Object, e As EventArgs) Handles btCancel.Click
        If Not btStart.Enabled Then
            ' you should start OCR process in separated thread for get this code worked
            bContinue = False
            btStart.Enabled = True
        Else
            Close()
        End If
    End Sub

    Private Sub btStart_Click(sender As Object, e As EventArgs) Handles btStart.Click
        Dim pdf As Integer
        Dim hResult As Integer
        Dim OCRretcode As String

        ' Check if language file exists
        Dim langfile As String = m_Datapath + "ocrdats\" + PDFXOCR_Funcs.OCR_LangArrayW(m_Language) + "_pxvocr.dat"
        If Not System.IO.File.Exists(langfile) Then
            MessageBox.Show("Error: " + langfile + " does not exist.",
                "Language File Missing",
                MessageBoxButtons.OK,
                MessageBoxIcon.Exclamation)
            Return
        End If

        Dim key As String = "YOUR PRODUCT KEY"
        Dim code As String = "YOUR DEVELOPER CODE"
        hResult = PDFXOCR_Funcs.OCR_Init(pdf, key, code)

        If PDFXOCR_Funcs.IS_DS_FAILED(hResult) Then
            MessageBox.Show("OCR Initialization failure.")
        End If

        bContinue = True
        btStart.Enabled = False


        hResult = PDFXOCR_Funcs.OCR_SetCallback(pdf, m_CallbackFunc, 0)

        hResult = PDFXOCR_Funcs.OCR_LoadW(pdf, m_SourceFilename)
        If PDFXOCR_Funcs.IS_DS_FAILED(hResult) Then
            MessageBox.Show("Error loading file: " + vbCr + m_SourceFilename, "OCR Library Error")
            bContinue = False
            btStart.Enabled = True
            Return
        End If

        Dim Options As PDFXOCR_Funcs.PXO_Options = New PDFXOCR_Funcs.PXO_Options
        Options.blacklist = ""
        Options.whitelist = ""
        Options.raster_dpi = m_DPI
        Options.ImageFlags = PDFXOCR_Funcs.OCR_ImageProcessingFlags.OCR_Image_FastAutorotate
        Options.DataPath = m_Datapath
        Options.lang = m_Language
        Options.RegionMode = PDFXOCR_Funcs.OCR_RegionMode.OCR_Auto
        Options.reserved = 0

        Dim pxoPagelist As IntPtr = IntPtr.Zero 'null pointer passed to OCR_MakeSearchable() will result in all pages being OCRd.

        hResult = PDFXOCR_Funcs.OCR_MakeSearchable(pdf, Options, pxoPagelist)

        If PDFXOCR_Funcs.IS_DS_FAILED(hResult) Then
            MessageBox.Show("Error running searchable." + vbCr + "Error code: " + hResult.ToString("X"))
            bContinue = False
            btStart.Enabled = True
            Return
        Else
            OCRretcode = hResult.ToString()
        End If

        hResult = PDFXOCR_Funcs.OCR_SaveW(pdf, m_DestFilename)
        If PDFXOCR_Funcs.IS_DS_FAILED(hResult) Then
            MessageBox.Show("Error saving output PDF file." + vbCr + "Error code: " + hResult.ToString("X"))
            bContinue = False
            btStart.Enabled = True
            Return
        Else
            Dim outputstring As String
            outputstring = "File saved to: " + m_DestFilename + " (OCR_MakeSearchable returned: " + OCRretcode + ")"
            tbStatus.Text = outputstring
            tbStatus.Update()
        End If

        PDFXOCR_Funcs.OCR_Delete(pdf)
        bContinue = False
        btStart.Enabled = True

    End Sub

    Private Sub cbDPI_SelectedIndexChanged(sender As Object, e As EventArgs) Handles cbDPI.SelectedIndexChanged
        m_DPI = (1 + cbDPI.SelectedIndex) * 100
    End Sub
End Class
