﻿Imports System.Runtime.InteropServices

Public Class PDFXOCR_Funcs

    Public Shared Function IS_DS_SUCCESSFUL(x As Integer) As Boolean
        Return (x And &H80000000) = 0
    End Function
    Public Shared Function IS_DS_FAILED(x As Integer) As Boolean
        Return (x And &H80000000) <> 0
    End Function

    Public Delegate Function PXO_CALLBACK_FUNC(ByVal state As Integer, ByVal level As Integer, ByRef param As Integer) As Boolean

#Region "Document Operations"

    <DllImport("ocrtools")>
    Public Shared Function OCR_Init(ByRef pdf As Integer, <MarshalAs(UnmanagedType.LPStr)> ByVal key As String,
         <MarshalAs(UnmanagedType.LPStr)> ByVal devCode As String) As Integer
    End Function

    <DllImport("ocrtools")>
    Public Shared Function OCR_LoadW(pdf As Integer, <MarshalAs(UnmanagedType.LPWStr)> ByVal fName As String) As Integer
    End Function

    <DllImport("ocrtools")>
    Public Shared Function OCR_SaveW(pdf As Integer, <MarshalAs(UnmanagedType.LPWStr)> ByVal fName As String) As Integer
    End Function

    <DllImport("ocrtools")>
    Public Shared Function OCR_MakeSearchable(ByVal pdf As Integer, ByRef Options As PXO_Options, ByVal pagelist As IntPtr) As Integer
    End Function

    <DllImport("ocrtools")>
    Public Shared Function OCR_SetCallback(ByVal pdf As Integer, ByVal clbFn As PXO_CALLBACK_FUNC, ByVal clbParam As Integer) As Integer
    End Function

    <DllImport("ocrtools")>
    Public Shared Function OCR_Delete(ByRef pdf As Integer) As Integer
    End Function

#End Region
#Region "Structures and constants"
    Public Enum PXO_Language
        PXO_English
        PXO_French
        PXO_German
        PXO_Ukrainian
        PXO_Russian
        PXO_ChineseSimp
        PXO_ChineseTrad
        PXO_Swedish
        PXO_Indonesian
        PXO_Slovenian
        PXO_Serbian
        PXO_Tagalog
        PXO_Turkish
        PXO_Hungarian
        PXO_Finnish
        PXO_Italian
        PXO_Dutch
        PXO_Norwegian
        PXO_Japanese
        PXO_Vietnamese
        PXO_Spanish
        PXO_Slovakian
        PXO_Korean
        PXO_Greek
        PXO_Portuguese
        PXO_Bulgarian
        PXO_Latvian
        PXO_Lithuanian
        PXO_Polish
        PXO_Danish
        PXO_Czech
        PXO_Catalan
        PXO_Romanian
        PXO_Hindi
        PXO_Thai
        PXO_Hebrew
        PXO_Arabic
        PXO_LanguageSize
    End Enum


    Public Const OCR_NUM_LANGUAGES As Integer = PXO_Language.PXO_LanguageSize

    Public Shared ReadOnly OCR_LangFullArrayW() As String = {"english", "french", "german", "ukrainian", "russian", "chinese_simplified",
                                        "chinese_traditiona", "swedish", "indonesian", "slovenian", "serbian", "tagalog",
                                        "turkish", "hungarian", "finnish", "italian", "dutch", "norwegian", "japanese",
                                        "vietnamese", "spanish", "slovakian", "korean", "greek", "portuguese", "bulgarian",
                                        "latvain", "lithuanian", "polish", "danish", "czech", "catalan", "romanian", "hindi",
                                        "thai", "hebrew", "arabic"}

    Public Shared ReadOnly OCR_LangArrayW() As String = {"eng", "fra", "deu", "ukr", "rus", "chi_sim", "chi_tra", "swe",
                                        "ind", "slv", "srp", "tgl", "tur", "hun", "fin", "ita", "nld",
                                        "nor", "jpn", "vie", "spa", "slk", "kor", "ell", "por", "bul",
                                        "lav", "lit", "pol", "dan", "ces", "cat", "rom", "hin", "tha", "heb", "ara"}

    Public Enum PXO_CallbackStage
        PXOClb_Start = 1
        PXOClb_Processing
        PXOClb_Finish
    End Enum

    Public Enum OCR_RegionMode
        OCR_Auto = 1
        OCR_SingleColumn = 4
        OCR_VerticalText = 5
        OCR_Block = 6
        OCR_Line = 7
        OCR_Word = 8
        OCR_Symbol = 10
        OCR_AutoRotateImageOnly = 999
    End Enum

    <StructLayout(LayoutKind.Sequential, Pack:=1)>
    Public Structure PXO_Options
        Public lang As PXO_Language
        Public RegionMode As OCR_RegionMode
        <MarshalAs(UnmanagedType.BStr)>
        Public whitelist As String
        <MarshalAs(UnmanagedType.BStr)>
        Public blacklist As String
        <MarshalAs(UnmanagedType.BStr)>
        Public DataPath As String
        Public ImageFlags As Integer
        Public raster_dpi As Integer
        Public reserved As Integer 'reserved
    End Structure

    Public Enum OCR_ImageProcessingFlags
        OCR_Image_NoRotate = &H0
        OCR_Image_Autorotate = &H1
        OCR_Image_EdgeRefine = &H2
        OCR_Image_GaussianBlur = &H4
        OCR_Image_SuppressOutput = &H8 'only place text layer
        OCR_Image_FastAutorotate = &H11 'OCR_Image_Autorotate bit included
        OCR_Text_PlaceByLines = &H20 'smaller but less accurate output.
    End Enum

#End Region
End Class
